<script setup>
// TODO: Remove properties prop and replace it by Bloc ID only
import ButtonRounded from '@/component/ButtonRounded.vue'
import FileIcon from '@/component/FileIcon.vue'
import { Icon } from '@iconify/vue'
import { getHexFileColor, dateToLapsedTime } from '@/helper/file-util'
import { useFileContextMenu } from '@/store/file-context-menu'

defineProps({
  properties: {
    type: Object
  }
})

const fileContextMenuStore = useFileContextMenu()
</script>

<template>
  <div class="file-card" :data-bloc-id="properties.id">
    <div class="file-card__top-content" :style="{ backgroundColor: getHexFileColor(properties.type) }">
      <div class="file-card__icon-content">
        <ButtonRounded icon="mdi:star-outline">
          <Icon icon="mdi:star-outline" width="16px" height="16px" />
        </ButtonRounded>
        <ButtonRounded @click="fileContextMenuStore.show($event, properties)">
          <Icon icon="mdi:dots-vertical" width="16px" height="16px" />
        </ButtonRounded>
      </div>
    </div>
    <div class="file-card__bot-content">
      <div class="file-card__label">
        <FileIcon :type="properties.type" />
        <h4>{{ properties.name }}</h4>
      </div>
      <p class="file-card__edited">
        Edited {{ dateToLapsedTime(properties.edited_on) }}
      </p>
    </div>
  </div>
</template>

<style lang="scss" scoped>
  .file-card {
    display: flex;
    flex-direction: column;
    height: 192px;
    min-height: 150px;
    width: 320px;
    min-width: 320px;
    border-radius: 8px;
    overflow: hidden;
    transition-duration: 0.2s;
    &__top-content {
      flex: 1 1 50%;
      padding: 5px;
      //background-color: $secondary-green;
    }
    &__bot-content {
      flex: 1 1 57%;
      display: flex;
      flex-direction: column;
      justify-content: center;
      padding: 8px 1rem;
      gap: 13px;
      background-color: $complementary-gray-3;
    }
    &__icon-content {
      display: flex;
      gap: 1px;
      float: right;
      svg {
        display: block;
        margin: 0;
        color: $complementary-white-50;
      }
    }
    &__label {
      display: flex;
      gap: 10px;
      color: $complementary-white;
    }
    &__edited {
      color: $complementary-white-25;
    }
  }

  @media all and (max-height: 800px) {
    .file-card {
      height: 140px;
      min-width: 220px;
      &__label {
        font-size: 10px;
      }
      &__edited {
        font-size: 10px;
      }
    }
  }
</style>
